if select(2, UnitClass('player')) ~= 'HUNTER' then return end -- Bail if we aren't a hunter

--/run PetStanceAnchor:ClearAllPoints() PetStanceAnchor:SetPoint('CENTER', UIParent)
local anchor = CreateFrame('Frame', 'PetStanceAnchor', UIParent)
anchor:SetSize(1, 1)

anchor:SetPoint('BOTTOMRIGHT', PetActionButton10, 'TOPRIGHT', -12, 8)
anchor:SetMovable(true)
anchor:SetUserPlaced(true)
anchor:SetClampedToScreen(true)

local function OnDragStart(self, button)
	if IsShiftKeyDown() then
		self:Disable() -- disable to prevent clicking the button when we stop dragging the frame
		anchor:StartMoving()
	end
end

local function OnDragStop(self)
	anchor:StopMovingOrSizing()
	self:Enable()
end

local function ShouldShowBar() -- GetSpecialization(nil, true) ~= nil
	return PetHasActionBar() and not UnitIsDead('pet') and not UnitAffectingCombat('player') and not C_PetBattles.IsInBattle() and UnitCreatureFamily('pet') -- it doesn't appear to matter if the pet is in combat or not
end

local f = CreateFrame('Frame', 'PetStanceFrame', UIParent)
f:SetScript('OnEvent', function(self, event, ...)
	--print(event, ShouldShowBar(), PetHasActionBar(), not UnitIsDead('pet'), not UnitAffectingCombat('pet'))
	if event == 'PLAYER_REGEN_DISABLED' then
		self:Hide()
	--elseif event == 'PLAYER_REGEN_ENABLED' then
		--self:SetShown(ShouldShowBar())
	else
		if event == 'PET_BAR_HIDE' then
			return self:Hide()
		elseif event == 'PLAYER_LOGIN' then
			-- Make some buttons
			local prevButton
			for i = GetNumSpecializations(false, true), 1, -1 do
				local button = CreateFrame('CheckButton', nil, f, 'PetStanceButtonTemplate')
				button:SetID(i)
				if prevButton then
					button:SetPoint('BOTTOMRIGHT', prevButton, 'BOTTOMLEFT', -4, 0)
				else
					--button:SetPoint('BOTTOMRIGHT', PetActionButton10, 'TOPRIGHT', -12, 8)
					button:SetPoint('BOTTOMRIGHT', anchor)
					f:SetPoint('BOTTOMRIGHT', button, 6, -6)
				end
				prevButton = button
				
				local _, name, description, icon, bg, role = GetSpecializationInfo(i, false, true)
				button.icon:SetTexture(icon)
				
				if i == 1 then
					f:SetPoint('TOPLEFT', button, -6, 6)
				end
				
				--button:RegisterForDrag('LeftButton')
				--button:SetScript('OnDragStart', OnDragStart)
				--button:SetScript('OnDragStop', OnDragStop)
				button:SetScript('OnMouseDown', OnDragStart)
				button:SetScript('OnMouseUp', OnDragStop)
			end
		end
		self:SetShown(ShouldShowBar())
	end
end)
f:RegisterEvent('PLAYER_REGEN_ENABLED')
f:RegisterEvent('PLAYER_REGEN_DISABLED')
f:RegisterEvent('PLAYER_LOGIN')
-- we have to watch an absurd number of events to track whether the bar should be shown to support addons that replace the default pet bar
f:RegisterEvent('PET_BAR_UPDATE')
f:RegisterEvent('PET_BAR_HIDE')
f:RegisterEvent('PET_UI_UPDATE')
f:RegisterEvent('UPDATE_VEHICLE_ACTIONBAR')
f:RegisterUnitEvent('UNIT_PET', 'player')
f:RegisterUnitEvent('UNIT_FLAGS', 'pet') -- fires when the pet dies

f:SetBackdrop({
	bgFile = 'Interface/Tooltips/UI-Tooltip-Background',
	edgeFile = 'Interface/Tooltips/UI-Tooltip-Border', edgeSize = 16,
	insets = {left = 4, right = 4, top = 4, bottom = 4}
})
f:SetBackdropColor(0.2, 0.2, 0.2)
f:SetBackdropBorderColor(0.2, 0.2, 0.2)

-- Suppress chat messages from learning and unlearning abilities
local ChatSpam = {
	'^' .. ERR_PET_LEARN_ABILITY_S:gsub('%%s', '.-') .. '$',
	'^' .. ERR_PET_LEARN_SPELL_S:gsub('%%s', '.-') .. '$',
	'^' .. ERR_PET_SPELL_UNLEARNED_S:gsub('%%s', '.-') .. '$',
}

local function ChatFilter(self, event, msg, ...)
	for _, spam in ipairs(ChatSpam) do
		if strmatch(msg, spam) then return true end
	end
end

ChatFrame_AddMessageEventFilter('CHAT_MSG_SYSTEM', ChatFilter)